//--------------------------------------------------------------
//  残響生成器で使うオールパス･フィルタによる残響生成器
//
//  2023/06/20, Copyright (c) 2023 MIKAMI, Naoki
//--------------------------------------------------------------

#include "DelayUnit.hpp"

#ifndef REVERB_ALLPASS_HPP
#define REVERB_ALLPASS_HPP

class Allpass
{
public:
    // コンストラクタ
    Allpass(int delay, float g) : G0_(g), delay_(delay) {}

    // 全域通過フィルタの実行 
    float Execute(float x)
    {
        float vn = x + G0_*delay_;
        float yn = -G0_*vn + delay_;
        delay_ = vn;    // 遅延器に格納
        return yn;
    }

private:
    const float G0_;    // 減衰量を決める係数
    DelayUnit delay_;   // 遅延器
};
#endif  // REVERB_ALLPASS_HPP
