//--------------------------------------------------------------
//  残響生成器で使う櫛形フィルタによる残響生成器
//
//  2023/06/20, Copyright (c) 2023 MIKAMI, Naoki
//--------------------------------------------------------------

#include "DelayUnit.hpp"

#ifndef REVERB_COMB_HPP
#define REVERB_COMB_HPP

class Comb
{
public:
    // コンストラクタ
    Comb(int delay, float g) : G0_(g), delay_(delay) {}

    // 櫛形フィルタの実行
    float Execute(float x)
    {
        float yn = delay_;      // 遅延したデータの取得
        delay_ = x + G0_*yn;    // 遅延器に格納
        return yn;
    }

private:
    const float G0_;    // 減衰量を決める係数
    DelayUnit delay_;   // 遅延器
};
#endif  // REVERB_COMB_HPP
